using Toybox.WatchUi;
using Toybox.Graphics as Gfx;
using Toybox.System;
using Toybox.Application.Storage;
using Toybox.Time;
using Toybox.Time.Gregorian;
using Toybox.Activity;
using Toybox.ActivityMonitor;

const maxver=60*3;
//const clockfont= Gfx.FONT_XTINY;
//var glucose=0.15;
var glucoserate=0.0;
var glucosetime=0;
var sensorversion="";
var theight;
class GlucoseView extends WatchUi.View {
    function initialize() {
        View.initialize();
    }


var heartfont=Gfx.FONT_NUMBER_MEDIUM;
var heartheight;
var timeoff=0;
function onLayout(dc) {
//	timeoff= dc.getFontHeight(clockfont)/3;
	heartheight= dc.getFontHeight(heartfont);
//	timeoff= heartheight*.36;
	 if(System.SCREEN_SHAPE_RECTANGLE == screenShape) {
	 	timeoff=-theight*0.15;
		}
	else {
		if(width>340) {
			timeoff=theight*0.14;
			}
		}

		dc.setPenWidth(height*.02);
}
    function onUpdate(dc) { 
	dc.clearClip();
	dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_WHITE);
	 dc.clear();
	var unixnu=Time.now().value();
	var myTime = Gregorian.info(new Time.Moment(unixnu) , Time.FORMAT_MEDIUM);

	var vers=unixnu-glucosetime;
	
	dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_TRANSPARENT);
	if(vers<maxver) {
		var yorg=height*.58;
		var y=yorg;
		var x=width*.5;
	 	dc.drawText(x,y , Gfx.FONT_SYSTEM_NUMBER_THAI_HOT ,glucosestr,Gfx.TEXT_JUSTIFY_VCENTER| Gfx.TEXT_JUSTIFY_CENTER);
		if(glucoserate==-20) {
	 		dc.drawText(width*.9,y , Gfx.FONT_LARGE ,">",Gfx.TEXT_JUSTIFY_VCENTER| Gfx.TEXT_JUSTIFY_RIGHT);
			}
		else  {
			if(glucoserate==20) {
				dc.drawText(width*.9,y , Gfx.FONT_LARGE ,"<",Gfx.TEXT_JUSTIFY_VCENTER| Gfx.TEXT_JUSTIFY_RIGHT);
				}	
			}
		y+=height*0.12;
		var dlen=width*.6;
		var beg=dlen*vers/maxver;

		var dims=dc.getTextDimensions(sensorversion,Gfx.FONT_XTINY);
//		var dimg=dc.getTextDimensions(glucosestr,Gfx.FONT_SYSTEM_NUMBER_THAI_HOT);
		dc.setColor(Gfx.COLOR_PURPLE,Gfx.COLOR_WHITE);
		var xid=x-dims[0]/2;
		dc.fillRectangle(xid, y, dims[0]*vers/maxver, dims[1]);
		dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_TRANSPARENT);
	 	dc.drawText(x,y ,Gfx.FONT_XTINY,sensorversion, Gfx.TEXT_JUSTIFY_CENTER);
//		dc.setColor(0x170a0b, Gfx.COLOR_TRANSPARENT);
		dc.setColor(0xff5112, Gfx.COLOR_TRANSPARENT);

	
		if(dc has :setAntiAlias) {
			dc.setAntiAlias(true);
			}

		//var xline=xid-width*.01;
		if(glucoserate!=-20.0&&glucoserate!=20.0) {
//			var xline=dimg[0]/2-width*0.005;
//			var xline=dimg[0]/2-width*0.1;
			var xline=width*0.20;
			dc.drawLine(xline*.3, yorg+glucoserate*height*.05, xline, yorg);
			}
//		dc.fillRectangle(0, y, dims[0]*vers/maxver, dims[1]);
		dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_TRANSPARENT);
		}
	dc.drawText(wmid*0.99, timeoff, Gfx.FONT_NUMBER_HOT,   myTime.hour.format("%02d") + ":" + myTime.min.format("%02d"),Gfx.TEXT_JUSTIFY_CENTER );
//	dc.drawText(wmid, theight*.8+timeoff, Gfx.FONT_TINY,  myTime.day_of_week+" "+  myTime.day.format("%02d") + " " + myTime.month,Gfx.TEXT_JUSTIFY_CENTER );
	dc.drawText(wmid, theight*.8+timeoff, Gfx.FONT_TINY,  myTime.day_of_week+" "+  myTime.day + " " + myTime.month,Gfx.TEXT_JUSTIFY_CENTER );
	var load = System.getSystemStats().battery;
	dc.drawText(width*0.95,height*.33,Gfx.FONT_XTINY,load.format("%.0f")+"%", Gfx.TEXT_JUSTIFY_VCENTER|Gfx.TEXT_JUSTIFY_RIGHT);
	var actinfo=	Activity.getActivityInfo();
	var hr=0;
	if(actinfo!=null) {
		if(actinfo.currentHeartRate!=null)  {
			hr=actinfo.currentHeartRate;
			}
		}
	if(hr==0) { 
		if( Toybox.ActivityMonitor has :getHeartRateHistory) {
			var sensorIter = Toybox.ActivityMonitor.getHeartRateHistory(1, true);
			if(sensorIter==null) {
				return;
				}
			var HRS=sensorIter.next();
			if(HRS!=null && HRS.heartRate!= Toybox.ActivityMonitor.INVALID_HR_SAMPLE){
				hr = HRS.heartRate;
				}
			else {
				return;
				}
			}
		else {
			return;
			}
		}
	dc.drawText(wmid,height-heartheight*.88,heartfont,hr.format("%d"), Gfx.TEXT_JUSTIFY_CENTER);
	}

}
