using Toybox.WatchUi;
using Toybox.Graphics as Gfx;
using Toybox.System;
using Toybox.Application.Storage;
using Toybox.Time;
using Toybox.Time.Gregorian;
using Toybox.Activity;
using Toybox.ActivityMonitor;

var endlap=0;
class SportView extends WatchUi.View {
    function initialize() {
        View.initialize();
    }



var gluheight;
var hheight;
function onLayout(dc) {
	hheight= dc.getFontHeight(Gfx.FONT_NUMBER_MILD);
	 gluheight= dc.getFontHeight(Gfx.FONT_SYSTEM_NUMBER_THAI_HOT);
		dc.setPenWidth(height*.02);
}
    function onUpdate(dc) { 
	dc.clearClip();
	dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_WHITE);
	 dc.clear();
	var unixnu=Time.now().value();

	var myTime = Gregorian.info(new Time.Moment(unixnu) , Time.FORMAT_MEDIUM);
	dc.drawText(wmid, -hheight*.12, Gfx.FONT_NUMBER_MILD,    myTime.hour.format("%02d") + ":" + myTime.min.format("%02d"),Gfx.TEXT_JUSTIFY_CENTER );
	var vers=unixnu-glucosetime;
	
	var starty=hheight*.78-gluheight*.2;
	var y=starty+gluheight*0.8;
	if(vers<maxver) {
		var dlen=width*.6;
		var beg=dlen*vers/maxver;
		var x=width*.5;
		var dims=dc.getTextDimensions(sensorversion,Gfx.FONT_XTINY);
		dc.setColor(Gfx.COLOR_PURPLE,Gfx.COLOR_TRANSPARENT);
		var xid= x-dims[0]/2;
		dc.fillRectangle(xid, y+1, dims[0]*vers/maxver, dims[1]);
		dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_TRANSPARENT);
	 	dc.drawText(x,y ,Gfx.FONT_XTINY,sensorversion, Gfx.TEXT_JUSTIFY_CENTER);
	 	dc.drawText(width*.5,starty , Gfx.FONT_SYSTEM_NUMBER_THAI_HOT,glucosestr,Gfx.TEXT_JUSTIFY_CENTER);
		if(glucoserate==-20) {
	 		dc.drawText(width*.9,hheight , Gfx.FONT_LARGE ,">", Gfx.TEXT_JUSTIFY_RIGHT);
			}
		else  {
			if(glucoserate==20) {
				dc.drawText(width*.9,hheight  , Gfx.FONT_LARGE ,"<", Gfx.TEXT_JUSTIFY_RIGHT);
				}	
			}

//		dc.setColor(Gfx.COLOR_BLUE, Gfx.COLOR_TRANSPARENT);
		//dc.setColor(0x49099c, Gfx.COLOR_TRANSPARENT);

		dc.setColor(0xff5112, Gfx.COLOR_TRANSPARENT);
		if(dc has :setAntiAlias) {
			dc.setAntiAlias(true);
			}
		if(glucoserate!=20.0&&glucoserate!=-20.0) {
			var yp=starty+gluheight/2;
	//		var xline=xid-width*0.0093;
			var xline=width*.2;
			dc.drawLine(xline*.5, yp+glucoserate*height*.05, xline, yp);
			}
		dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_TRANSPARENT);
		}
	else {
		dc.setColor(Gfx.COLOR_BLACK, Gfx.COLOR_TRANSPARENT);
		}
	if(locinfo!=null) {
		var showspeed=locinfo.speed*toshowspeed;
		dc.drawText(width*.98,height*.59 ,Gfx.FONT_NUMBER_HOT,showspeed.format("%.0f"), Gfx.TEXT_JUSTIFY_VCENTER|Gfx.TEXT_JUSTIFY_RIGHT);
		dc.drawText(width,y ,Gfx.FONT_XTINY,speedunits, Gfx.TEXT_JUSTIFY_RIGHT);

		}
	else {
		if(activityrecord==null) {
			dc.drawText(wmid,height*.54 ,Gfx.FONT_LARGE,"Finished",  Gfx.TEXT_JUSTIFY_VCENTER|Gfx.TEXT_JUSTIFY_CENTER);
			}
		else {
			dc.drawText(wmid,height*.54 ,Gfx.FONT_LARGE,"Waiting for GPS",  Gfx.TEXT_JUSTIFY_VCENTER|Gfx.TEXT_JUSTIFY_CENTER);
			}
		}
	var hr=0;
	if(actinfo!=null) {
		if(actinfo.elapsedDistance!=null) {
			var dist= actinfo.elapsedDistance*toshowdistance;
			dc.drawText(width*.13,height*.59 ,Gfx.FONT_NUMBER_HOT, dist.format("%.1f"),Gfx.TEXT_JUSTIFY_LEFT);
			if(showdistanceunit) {
				dc.drawText(width*.12,height*.65 ,Gfx.FONT_XTINY,distanceunits, Gfx.TEXT_JUSTIFY_RIGHT);
				}
			}
		if(actinfo.currentHeartRate!=null)  {
			hr=actinfo.currentHeartRate;
			}
		}
	if(unixnu<endlap) {
		 dc.drawText(width*.04, y+0.01*height , Gfx.FONT_XTINY,lapstr1,Gfx.TEXT_JUSTIFY_LEFT );
		dc.drawText(0, height*.57 , Gfx.FONT_NUMBER_MEDIUM,lapstr2,Gfx.TEXT_JUSTIFY_VCENTER|Gfx.TEXT_JUSTIFY_LEFT ); 
		}


	if(hr==0) { 
		if( Toybox.ActivityMonitor has :getHeartRateHistory) {
			var sensorIter = Toybox.ActivityMonitor.getHeartRateHistory(1, true);
			if(sensorIter==null) {
				return;
				}
			var HRS=sensorIter.next();
			if(HRS!=null && HRS.heartRate!= Toybox.ActivityMonitor.INVALID_HR_SAMPLE){
				hr = HRS.heartRate;
				}
			else {
				return;
				}
			}
		else {
			return;
			}
		}
	dc.drawText(wmid,height-hheight*.88,Gfx.FONT_NUMBER_MILD,hr.format("%d"), Gfx.TEXT_JUSTIFY_CENTER);
	}

}
